-- ToME - Tales of Maj'Eyal
-- Copyright (C) 2009, 2010, 2011, 2012 Nicolas Casalini
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Nicolas Casalini "DarkGod"
-- darkgod@te4.org

newEntity{ slot = "MAINHAND", offslot = "OFFHAND",
	type = "weapon", subtype="whip",
	add_name = " (#COMBAT#)",
	display = "|", color=colors.SLATE, image = resolvers.image_material("whip", "leather"),
	moddable_tile = resolvers.moddable_tile("whip"),
	encumber = 3,
	rarity = 30,
	metallic = true,
	combat = { talented = "whip", damrange = 1.1, physspeed = 1, sound = "actions/melee", sound_miss = "actions/melee_miss",},
	desc = [[Sharp, long and deadly.]],
	randart_able = { attack=40, physical=80, spell=20, def=10, misc=10 },
	egos = "/data/general/objects/egos/weapon.lua", egos_chance = { prefix=resolvers.mbonus(40, 5), suffix=resolvers.mbonus(40, 5) },

	name = "wyrmhide whip", short_name = "wyrm",
	level_range = {20, 30},
	require = { stat = { dex=24 }, },
	cost = 15,
	material_level = 3,
	combat = {
		dam = resolvers.rngavg(20,26),
		apr = 4,
		physcrit = 5,
		dammod = {dex=0.8, wil=0.4},
		convert_damage ={},
	},
	wielder = {}, 
		resolvers.generic(function(e)
			--local c = {red, blue, white}
			local cc = rng.range(1, 3)
			if cc == 1 then e.combat.convert_damage = {[DamageType.FIRE] = 50} end 
			if cc == 2 then e.combat.convert_damage = {[DamageType.LIGHTNING] = 50} end
			if cc == 3 then e.combat.convert_damage = {[DamageType.COLD] = 50} end
		end),
}

newEntity{ slot = "MAINHAND", offslot = "OFFHAND",
	type = "weapon", subtype="whip",
	add_name = " (#COMBAT#)",
	display = "|", color=colors.SLATE, image = resolvers.image_material("whip", "leather"),
	moddable_tile = resolvers.moddable_tile("whip"),
	encumber = 3,
	rarity = 30,
	metallic = true,
	combat = { talented = "whip", damrange = 1.1, physspeed = 1, sound = "actions/melee", sound_miss = "actions/melee_miss",},
	desc = [[Sharp, long and deadly.]],
	randart_able = { attack=40, physical=80, spell=20, def=10, misc=10 },
	egos = "/data/general/objects/egos/weapon.lua", egos_chance = { prefix=resolvers.mbonus(40, 5), suffix=resolvers.mbonus(40, 5) },
	name = "multihued whip", short_name = "multihued",
	level_range = {40, 50},
	require = { stat = { dex=48 }, },
	cost = 35,
	material_level = 5,
	combat = {
		dam = resolvers.rngavg(40,45),
		apr = 6,
		physcrit = 8,
		dammod = {dex=0.8, wil=0.5, cun=0.3},
		convert_damage ={
			[DamageType.FIRE] = 15,
			[DamageType.COLD] = 15,
			[DamageType.ACID] = 15,
			[DamageType.LIGHTNING] = 15,
			[DamageType.NATURE] = 15,
		},
	},
}

newEntity{
	slot = "FINGER",
	type = "jewelry", subtype="ring", image = resolvers.image_material("ring", {"copper", "steel", "gold", "stralite", "voratun"}),
	display = "=",
	encumber = 0.1,
	rarity = 18,
	desc = [[Rings can have magical properties.]],
	randart_able = { attack=40, physical=40, spell=40, def=40, misc=40 },
	-- Most rings are ego items
	egos = "/data/general/objects/egos/rings.lua", egos_chance = { prefix=resolvers.mbonus(50, 40), suffix=resolvers.mbonus(50, 40) }, egos_chance_decay = 0.5,
	name = "gemmed ring", color = colors.PURPLE,
	unided_name = "gemmed ring", short_name = "gemmed",
	level_range = {40, 50},
	cost = 45,
	material_level = 5,
	ego_bonus_mult = -0.5,
	wielder = {},
	resolvers.generic(function(e)
		local Stats = require "engine.interface.ActorStats"
		--local c = {red, blue, white}
		local cc = rng.range(1, 5)
		if cc == 1 then 
			e.wielder.resists = {}
			e.wielder.resists = {all=10} 
		end 
		if cc == 2 then 
			e.wielder.inc_stats = {}
			e.wielder.inc_stats = { [Stats.STAT_STR] = 5, [Stats.STAT_DEX] = 5, [Stats.STAT_MAG] = 5, [Stats.STAT_WIL] = 5, [Stats.STAT_CUN] = 5, [Stats.STAT_CON] = 5, } 
		end 
		if cc == 3 then 
			e.wielder.combat_def = 10
		end 
		if cc == 4 then 
			e.wielder.inc_damage = {}
			e.wielder.inc_damage = {all=10} 
		end 
		if cc == 5 then 
			e.wielder.stun_immune = 0.6
		end 
	end),

}
